"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.compatiableParse = compatiableParse;

var _dateFns = require("date-fns");

/**
 * @file
 * Various date-related analysis methods
 */

/**
 * Parsing value to Date object
 */
function compatiableParse(value, formatToken, baseDate, locale) {
  let result = null;

  if (value) {
    if (formatToken) {
      baseDate = baseDate || new Date();
      result = (0, _dateFns.parse)(value, formatToken, baseDate, {
        locale
      });
    }

    if (!(0, _dateFns.isValid)(result)) {
      result = (0, _dateFns.parseISO)(value);
    }

    if (!(0, _dateFns.isValid)(result)) {
      result = new Date(Date.parse(value));
    }

    const yearInvalid = (0, _dateFns.isValid)(result) && String(result.getFullYear()).length > 4;

    if (!(0, _dateFns.isValid)(result) || yearInvalid) {
      result = null;
    }
  }

  return result;
}