"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

class Logger {
  /**
   * specify prefix
   * @param {string} prefix
   */
  constructor(prefix) {
    this._prefix = prefix;
  }

  _isEmpty(value) {
    return value === null || value === undefined || value === '';
  }

  _baseLog() {
    let method = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'log';

    if (typeof console[method] === 'function') {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      const messages = [...args];

      if (!this._isEmpty(this._prefix)) {
        messages.unshift(this._prefix, ':');
      }

      console[method](...messages);
    }
  }

  log() {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    this._baseLog('log', ...args);
  }

  warn() {
    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    this._baseLog('warn', ...args);
  }

  error() {
    for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    this._baseLog('error', ...args);
  }

  info() {
    for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
      args[_key5] = arguments[_key5];
    }

    this._baseLog('info', ...args);
  }

}

var _default = Logger;
exports.default = _default;