"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));

var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));

var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));

class Store {
  constructor(initialState) {
    this._state = (0, _assign.default)({}, initialState);
    this._listeners = [];
  }

  subscribe(listener) {
    this._listeners.push(listener);

    const unsubscribe = () => {
      var _context;

      const index = (0, _indexOf.default)(_context = this._listeners).call(_context, listener);

      if (index > -1) {
        var _context2;

        (0, _splice.default)(_context2 = this._listeners).call(_context2, index, 1);
      }
    };

    return unsubscribe;
  }

  setState(state) {
    (0, _assign.default)(this._state, (0, _assign.default)({}, state));

    for (const listener of this._listeners) {
      if (typeof listener === 'function') {
        listener(this._state);
      }
    }
  }

  getState() {
    return this._state;
  }

}

var _default = Store;
exports.default = _default;